'
' Savage Worlds Initiative script
' This script sets up a deck of cards to use for initiative. 
' Using this deck, initiative cards are drawn for each active character or NPC.
' The status settings for characters (set in the preferences) must include On Hold and Incapacitated and Surprised
' On Hold characters will retain their card. Incapacitated characters will not get a card.
' Deck and Character Initiative information is stored using GetField & SetField methods
'

' Things to do:



#commandset Savage Worlds Initiative
#event OnStartup SWCardDrawingInitDeck
#register /SWInit SWInitiative Get Initiative for all characters on the map
#register /SWGetInit SWGetInitiative Character List all characters including Players and NPC's
#register /SWShuffle ShuffleDeck Shuffles the initiative deck
#register /Group SWSetGroup Sets all the selected NPCs to be the same group for initiative purposes.
#register /RGroup SWRemoveGroups Removes all group asignments from all charcters on the map.
#register /LH LevelHeaded This will assign the Level Headed edge to a charcter so that he will get two cards.
#register /RLH RemoveLevelHeaded This will remove the Level Headed edge from a charcter.
#register /ILH ImprovedLevelHeaded This will assign the Improved Level Headed edge to a charcter so that he will get two cards.
#register /RILH RemoveImprovedLevelHeaded This will remove the Improved Level Headed edge from a charcter.
#register /Q Quick This will assign the Quick edge to a charcter so that he a new card if dealt 5 or less.
#register /RQ RemoveQuick This will remove the Quick edge from a charcter.

Sub LevelHeaded
	'loop through all characters and add LevelHeaded Attribute to the named character
	s = GetCurrentSession()
	cs = GetChatSession()
	ci = cs.GetLastItem()
	CharName = Trim(ci.text)
	
	
	If Len( CharName) = 0 Then
		ci.Text = "You must supply a Character name!"
		Exit Sub
	End If
   	n = s.GetSyncCharCount() 
   	CharacterNotFound = 1
	For i = 1 to n
		c = s.GetSyncChar( i)
		'Check if Character is Selected on the map
		If LCase(c.Name) = LCase(CharName) Then
			CharacterNotFound = 0
			LevelHeadedAlready = c.GetField("LevelHeaded")
			'Check for nul string
			If Len( LevelHeadedAlready)=0 Then LevelHeadedAlready = 0
			If LevelHeadedAlready Then
				ci.text = CharName & " is already Level Headed."
			Else
				c.SetField "LevelHeaded", "1"
				ci.text = CharName & " set to Level Headed."
			End If
		End If
	Next    
	If CharacterNotFound Then
		ci.text = "No such character."
	End If
End Sub

Sub RemoveLevelHeaded
	'loop through all characters and remove LevelHeaded Attribute to the named character
	s = GetCurrentSession()
	cs = GetChatSession()
	ci = cs.GetLastItem()
	CharName = Trim (ci.text)
	
	If Len( CharName) = 0 Then
		ci.Text = "You must supply a Character name!"
		Exit Sub
	End If
   	n = s.GetSyncCharCount() 
   	CharacterNotFound = 1
	For i = 1 to n
		c = s.GetSyncChar( i)
		'Check if Character is Selected on the map
		If LCase(c.Name) = LCase(CharName) Then
			CharacterNotFound = 0
			LevelHeadedAlready = c.GetField("LevelHeaded")
			'Check for nul string
			If Len( LevelHeadedAlready)=0 Then LevelHeadedAlready = 0
			If LevelHeadedAlready Then
				c.SetField "LevelHeaded", "0"
				ci.text = CharName & " is no longer Level Headed."
			Else
				ci.text = CharName & " wasn't Level Headed."
			End If
		End If
	Next    
	If CharacterNotFound Then
		ci.text = "No such character."
	End If
End Sub

Sub ImprovedLevelHeaded
	'loop through all characters and add ImprovedLevelHeaded Attribute to the named character
	s = GetCurrentSession()
	cs = GetChatSession()
	ci = cs.GetLastItem()
	CharName = Trim(ci.text)
	
	
	If Len( CharName) = 0 Then
		ci.Text = "You must supply a Character name!"
		Exit Sub
	End If
   	n = s.GetSyncCharCount() 
   	CharacterNotFound = 1
	For i = 1 to n
		c = s.GetSyncChar( i)
		'Check if Character is Selected on the map
		If LCase(c.Name) = LCase(CharName) Then
			CharacterNotFound = 0
			ImprovedLevelHeadedAlready = c.GetField("ImprovedLevelHeaded")
			'Check for nul string
			If Len( ImprovedLevelHeadedAlready)=0 Then ImprovedLevelHeadedAlready = 0
			If ImprovedLevelHeadedAlready Then
				ci.text = CharName & " is already Improved Level Headed."
			Else
				c.SetField "ImprovedLevelHeaded", "1"
				ci.text = CharName & " set to Improved Level Headed."
			End If
		End If
	Next    
	If CharacterNotFound Then
		ci.text = "No such character."
	End If
End Sub

Sub RemoveImprovedLevelHeaded
	'loop through all characters and remove ImprovedLevelHeaded Attribute to the named character
	s = GetCurrentSession()
	cs = GetChatSession()
	ci = cs.GetLastItem()
	CharName = Trim (ci.text)
	
	If Len( CharName) = 0 Then
		ci.Text = "You must supply a Character name!"
		Exit Sub
	End If
   	n = s.GetSyncCharCount() 
   	CharacterNotFound = 1
	For i = 1 to n
		c = s.GetSyncChar( i)
		'Check if Character is Selected on the map
		If LCase(c.Name) = LCase(CharName) Then
			CharacterNotFound = 0
			ImprovedLevelHeadedAlready = c.GetField("ImprovedLevelHeaded")
			'Check for nul string
			If Len( ImprovedLevelHeadedAlready)=0 Then ImprovedLevelHeadedAlready = 0
			If ImprovedLevelHeadedAlready Then
				c.SetField "ImprovedLevelHeaded", "0"
				ci.text = CharName & " is no longer Improved Level Headed."
			Else
				ci.text = CharName & " wasn't Improved Level Headed."
			End If
		End If
	Next    
	If CharacterNotFound Then
		ci.text = "No such character."
	End If
End Sub

Sub Quick
	'loop through all characters and add Quick Attribute to the named character
	s = GetCurrentSession()
	cs = GetChatSession()
	ci = cs.GetLastItem()
	CharName = Trim(ci.text)
	
	
	If Len( CharName) = 0 Then
		ci.Text = "You must supply a Character name!"
		Exit Sub
	End If
   	n = s.GetSyncCharCount() 
   	CharacterNotFound = 1
	For i = 1 to n
		c = s.GetSyncChar( i)
		'Check if Character is Selected on the map
		If LCase(c.Name) = LCase(CharName) Then
			CharacterNotFound = 0
			QuickAlready = c.GetField("Quick")
			'Check for nul string
			If Len( QuickAlready)=0 Then QuickAlready = 0
			If QuickAlready Then
				ci.text = CharName & " is already Quick."
			Else
				c.SetField "Quick", "1"
				ci.text = CharName & " set to Quick."
			End If
		End If
	Next    
	If CharacterNotFound Then
		ci.text = "No such character."
	End If
End Sub


Sub RemoveQuick
	'loop through all characters and remove Quick Attribute to the named character
	s = GetCurrentSession()
	cs = GetChatSession()
	ci = cs.GetLastItem()
	CharName = Trim (ci.text)
	
	If Len( CharName) = 0 Then
		ci.Text = "You must supply a Character name!"
		Exit Sub
	End If
   	n = s.GetSyncCharCount() 
   	CharacterNotFound = 1
	For i = 1 to n
		c = s.GetSyncChar( i)
		'Check if Character is Selected on the map
		If LCase(c.Name) = LCase(CharName) Then
			CharacterNotFound = 0
			QuickAlready = c.GetField("Quick")
			'Check for nul string
			If Len( QuickAlready)=0 Then QuickAlready = 0
			If QuickAlready Then
				c.SetField "Quick", "0"
				ci.text = CharName & " is no longer Quick."
			Else
				ci.text = CharName & " wasn't Quick."
			End If
		End If
	Next    
	If CharacterNotFound Then
		ci.text = "No such character."
	End If
End Sub


Sub SWSetGroup
	'loop through all characters and do something with them 
	s = GetCurrentSession()
	cs = GetChatSession()
	ci = cs.GetLastItem()
	If Len( Trim( ci.Text)) = 0 Then
		ci.Text = "You must supply a group name!"
		Exit Sub
	End If
   	GroupName = ci.Text
 
   	s.Sync 
   	n = s.GetSyncCharCount() 
   	ci.PlayerFrom = "NPC's Set to Group" & GroupName
   	ci.Action = ""
   	ci.text = ""


	For i = 1 to n
		c = s.GetSyncChar( i)
		'Check if Character is Selected on the map
		If c.Selected Then c.SetField "NPCGroup", GroupName
	Next    
    
End Sub

Sub SWRemoveGroups
	'loop through all characters and do something with them 
	s = GetCurrentSession()
	cs = GetChatSession()
	ci = cs.GetLastItem()
   	s.Sync 
   	n = s.GetSyncCharCount() 
   	ci.PlayerFrom = "All NPC groups removed."
   	ci.Action = ""
   	ci.text = ""

	For i = 1 to n
		c = s.GetSyncChar( i)
		'Check if Character is Selected on the map
		c.SetField "NPCGroup", ""
	Next    
    
End Sub

Sub SWCardDrawingInitDeck
	'This subroutine is called on startup to set a standard 
	'deck of cards including both Jokers. Specifically used for initiative.
	SWCardDrawingSetDeck "0;1;2;3;4;5;6;7;8;9;10;11;12;13;14;15;16;17;18;19;20;21;22;23;24;25;26;27;28;29;30;31;32;33;34;35;36;37;38;39;40;41;42;43;44;45;46;47;48;49;50;51;52;53"
End Sub

Sub SWCardDrawingSetDeck( sDeck)
	'This subroutine sets up both the Base Initiative deck and the 
	'current Initiative deck. It is only called as part of startup.
	s = GetCurrentSession()
        'This sets two new permanent fields for the session 
        'SWBaseDeck is all the cards in a deck
        'SWCurrentDeck is the cards remaining in the current deck
	s.SetField "SWBaseDeck", Trim( sDeck)
	s.SetField "SWCurrentDeck", Trim( sDeck)
	s.SetField "SWCardFaces", "BlackJoker;RedJoker;AS;AH;AD;AC;KS;KH;KD;KC;QS;QH;QD;QC;JS;JH;JD;JC;10S;10H;10D;10C;9S;9H;9D;9C;8S;8H;8D;8C;7S;7H;7D;7C;6S;6H;6D;6C;5S;5H;5D;5C;4S;4H;4D;4C;3S;3H;3D;3C;2S;2H;2D;2C;No Card"
	s.SetField "JokerDealt", "0"
End Sub


Sub SWInitiative
	'loop through all characters and do something with them 
	s = GetCurrentSession()
	cs = GetChatSession()
	ci = cs.GetLastItem()
 
	s.Sync 
	NumChar = s.GetSyncCharCount() 
	ci.PlayerFrom = "Cards dealt are"
	ci.Action = ""
	ci.text = "<br>"

	'Set the Card array
	CardFaces = s.GetField( "SWCardFaces")
	Faces = split( CardFaces, ";")

	MustShuffle = Int(s.GetField("JokerDealt"))

	If MustShuffle Then 
		ShuffleDeck
	End If
	
	'Reset Shuffle Flag
	s.SetField "JokerDealt", "0"


	For i = 1 to NumChar
		' Get Current character
		c = s.GetSyncChar( i)
		
		'Check if Character is on the map
		If Not c.x = -100 Then
		
			'Get the NPC's GroupName
			GroupName = c.GetField("NPCGroup")
			
			'Check if there was a GroupName
			InGroup = Int(1)			
			If Len (GroupName) = 0 then InGroup = Int(0)

			OtherMemberHasCard = Int(0)
			
			'If there was a group 
			If InGroup Then
				'Assume no other Group members	
				
				'Then check for lower number group members
				For j = 1 to i-1
					c2 = s.GetSyncChar( j)
					GroupName2= c2.GetField("NPCGroup")
					If Len(GroupName2) <> 0 Then
						If GroupName2 = GroupName Then 
							If c2.x <> -100 And LCase(c2.status) <> "on hold" Then
								OtherMemberHasCard = Int(1)
							End If
						End If
					End If
				Next
			End If

			
			'Check the characters status
			Select Case c.Status
			Case "On Hold"
				CardNo = c.GetField("SWInit")
				'Check to make sure character has a card
				If Len(CardNo) = 0 Then
					c.SetField "SWInit", "54"
				End If	
			Case "Incapacitated"
				'Set to no card (54)
				c.SetField "SWInit", "54"
			Case "Surprised"
				'Set to no card (54)
				c.SetField "SWInit", "54"
			Case Else
				If OtherMemberHasCard Then
					CardNo = "54"
				Else
					CardNo = SWDrawACard
				End If
					
				'Check to see if a Joker was drawn
				If CardNo = 0 or CardNo = 1 Then s.SetField "JokerDealt", "1"
				'Check if character is Level Headed or Improved Level Headed or Quick
				IsQuick=0
				IsLevelHeaded=0
				IsImprovedLevelHeaded=0

				IsQuick = c.GetField("Quick")
				If Len(IsQuick) = 0 Then IsQuick=0

				IsLevelHeaded = c.GetField("LevelHeaded")
				If Len(IsLevelHeaded) = 0 Then IsLevelHeaded=0

				IsImprovedLevelHeaded = c.GetField("ImprovedLevelHeaded")
				If Len(IsImprovedLevelHeaded) = 0 Then IsImprovedLevelHeaded=0

				'Draw 0,1 or 2 cards
				MoreCards = 0
				If IsLevelHeaded Then MoreCards = 1
				If IsImprovedLevelHeaded Then MoreCards = 2
				For x = 1 to MoreCards
					NextCard = SWDrawACard
					'Check to see if a Joker was drawn
					If NextCard = 0 or NextCard= 1 Then
						s.SetField "JokerDealt", "1"
					End If
					'Get the highest Face card (lowest number)
					If Int(NextCard) < Int(CardNo) Then 
						ci.Text = ci.Text & c.Name & " rejected " & Faces(CardNo) & " <i>(Level Headed)</i><br>"
						CardNo = NextCard
					Else
						ci.Text = ci.Text & c.Name & " rejected " & Faces(NextCard) & " <i>(Level Headed)</i><br>"
					End If
				Next
				
				If IsQuick Then
					'While card is less then 5 draw another
					While CardNo > 37 
						ci.Text = ci.Text & c.Name & " Rejected " & Faces(CardNo) & " <i>(Quick)</i><br>"
						CardNo = SWDrawACard
						'Check to see if a Joker was drawn
						If CardNo = 0 or CardNo = 1 Then s.SetField "JokerDealt", "1"

					WEnd
				End If
				
				'Set the current characters SW Initiative
		      		c.SetField "SWInit", CardNo
				
			End Select
		Else
			'Off Map so set to no card (54)
			c.SetField "SWInit", "54"
		End If
	Next    
        SWGetInitiative
End Sub


Sub SWGetInitiative

   	'loop through all characters and do something with them 
   	s = GetCurrentSession()
   	cs = GetChatSession()
   	ci = cs.GetLastItem()

	'Set the Card array
	CardFaces = s.GetField( "SWCardFaces")
	Faces = split( CardFaces, ";")

 
   	s.Sync 
   	n = s.GetSyncCharCount()
   	ci.PlayerFrom = "Cards dealt are"
   	ci.Action = ""
   	ci.text = ci.text & "----------------<br>"

	' It seems that the sort utility moves the array over by one
	' ********************	
	Dim CardArray ()
	ReDim CardArray (2,n)


	For i = 1 to n
		CardArray (0,i-1) = i
		c = s.GetSyncChar( i)
		If Len(c.GetField("SWInit")) = 0 Then c.SetField "SWInit", "54"
		CardArray (1,i-1) = c.GetField("SWInit")
	Next

	

	fd = arraySort(CardArray,1) 
	' ********************	

	' when displaying sorted initiative don't display members of group on hold or inc
	' display the first character of the group's card with the group name
	' dont display the card for any other group member
	' replace character name with Group Name when displaying card.
	' part of this is for getinitiatives function
			



	' Show cards on hold
	For j = 0 to n-1
		i = CardArray(0,j)
		c = s.GetSyncChar( i)
		'Make sure character is on the map
		If Not c.x = -100 Then

			'Gets the current characters SW Initiative
			CardNo = c.GetField("SWInit")
			CardType = Faces(CardNo)
			
			If LCase(c.Status) =  "on hold" Then
				ci.text = ci.text & " <B>" & c.name & "</B>" & ": " & "On Hold (" & CardType & ")<br>"
			End If
		End If
		
	Next
	' ********************	
	'Show active Character cards
	For j = 0 to n-1
		i = CardArray(0,j)
		c = s.GetSyncChar( i)
		'Make sure character is on the map
		If Not c.x = -100 Then

			'Gets the current characters SW Initiative
			CardNo = c.GetField("SWInit")
			CardType = Faces(CardNo)
			Select Case LCase(c.Status) 
			Case "on hold"
				' Do nothing
			Case "incapacitated"
				' Do nothing
			Case "surprised"
				' Do nothing
			Case Else
				'Get the NPC's GroupName
				GroupName = c.GetField("NPCGroup")
							
				'Check if there was a GroupName
				InGroup = Int(1)			
				If Len (GroupName) = 0 then InGroup = Int(0)
				FirstInGroup = Int(1)
				If InGroup Then
					'Check to see if first character on the map
					'Then check for lower number group members
					For k = 1 to i-1
						'get character
						c2 = s.GetSyncChar( k)
						'See if on map
						If c2.x <> -100 And LCase(c2.status) <> "on hold" Then
							GroupName2= c2.GetField("NPCGroup")
							If Len(GroupName2) <> 0 Then
								If GroupName2 = GroupName Then FirstInGroup = Int(0)
							End If
						End If	
					Next					
					'if so, display card
					If FirstInGroup Then
						ci.text = ci.text & " <B>" & GroupName & "</B>" & ": " & CardType & "<br>"
						
					End If
				Else
					ci.text = ci.text & " <B>" & c.name & "</B>" & ": " & CardType & "<br>"
				End If

			End Select
		End If
		
	Next
	' ********************	
	'Show Incapacitated *** This could be removed.
	For j = 0 to n-1
		i = CardArray(0,j)
		c = s.GetSyncChar( i)
		'Make sure character is on the map
		If Not c.x = -100 Then

			'Gets the current characters SW Initiative
			CardNo = c.GetField("SWInit")
			CardType = Faces(CardNo)
			If LCase(c.Status) = "incapacitated" Then
				ci.text = ci.text & " <B>" & c.name & "</B>" & ": " & "Incapacitated (" & CardType & ")<br>"
			End If
		End If
		
	Next
	' ********************	
	'Show Surprise
	For j = 0 to n-1
		i = CardArray(0,j)
		c = s.GetSyncChar( i)
		'Make sure character is on the map
		If Not c.x = -100 Then

			'Gets the current characters SW Initiative
			CardNo = c.GetField("SWInit")
			CardType = Faces(CardNo)
			If LCase(c.Status) = "surprised" Then
				ci.text = ci.text & " <B>" & c.name & "</B>" & ": " & "Surprised (" & CardType & ")<br>"
			End If
		End If
		
	Next
	' ********************	

    
End Sub



Function ShuffleDeck
	'loop through all characters and do something with them 
	s = GetCurrentSession()
	cs = GetChatSession()
	ci = cs.GetLastItem()
 
     	ci.PlayerFrom = "Shuffling Initiative Deck"
     	ci.Action = ""
     	ci.Text = "<br>"
 
	s.Sync 
	NumChar = s.GetSyncCharCount() 

	addlog "Shuffling deck" 
	'Shuffle by adding all possible cards back into current deck...
	'Get the base deck, put it in an array, count the array elements	
	deck = s.GetField("SWBaseDeck")
	a = split( deck, ";")
	NumCards = UBound( a) + 1
	
	'Then remove the cards that characters are using (On Hold)...
	For i = 1 to NumChar
		' For each Character Check if On Hold
		c = s.GetSyncChar( i)
		If c.Status = "On Hold" Then
			' If so, get that characters card
			CardNo = c.GetField("SWInit")
			' If "No Card" do nothing
			If CardNo = "54" Then
				'Do Nothing
			Else
				' Else set that array element to "Remove" so it is taken from new deck
				a(CardNo) = "Remove"
			End If	
		End If
	Next
	' Run through the array and add each element that isn't -1 to the string.
	' Assign the string again.
	'erase the deck variable		
	deck = ""
	'relace each card in the deck variable, other than the "Remove"ed cards..
	For j = 0 to NumCards - 1
		If Not a(j) = "Remove" Then
			deck = deck & a(j) & ";"
		End If
	Next
	'get rid of the trailing semicolon cuz it will mess up the next Split()
	If Right( deck, 1) = ";" Then deck = Left( deck, Len( deck) -1)
	
	'Set the current deck to be updated with the right number of cards
	s.SetField "SWCurrentDeck", deck

End Function


Function SWDrawACard( )
	s = GetCurrentSession()
	deck = s.GetField( "SWCurrentDeck")
	a = split( deck, ";")
	n = UBound( a) 

	'Check for a nul deck
	If n = 0 Then 
		ShuffleDeck
		deck = s.GetField( "SWCurrentDeck")
		a = split( deck, ";")
		n = UBound( a) 
	End If
	
	
	'Randomize the random number generator
	Randomize
	'randomly select a remaining card
	p = Int((n+1) * Rnd() )
	pick = a(p)
	'erase the deck variable		
	deck = ""
	'relace each card in the deck variable, other than the one chosen.
	For j = 0 to n
		If j <> p Then
			deck = deck & a(j) & ";"
		End If
	Next
	'get rid of the trailing semicolon cuz it will mess up the next Split()
	If Right( deck, 1) = ";" Then deck = Left( deck, Len( deck) -1)
	
	'Set the current deck to be updated with the right number of cards
	s.SetField "SWCurrentDeck", deck

	SWDrawACard=pick
End Function


'==============================================
function arraySort( arToSort, sortBy )
'==============================================

	Dim c, d, e, smallestValue, smallestIndex, tempValue
	
	For c = 0 To uBound( arToSort, 2 ) - 1
	
		smallestValue = arToSort( sortBy, c )
		smallestIndex = c
	
		For d = c + 1 To uBound( arToSort, 2 ) - 1
			if Int(arToSort( sortBy, d )) < Int(smallestValue) Then
				smallestValue = arToSort( sortBy, d )
				smallestIndex = d
			End if
		Next
		
		if smallestIndex <> c Then 'swap
			For e = 0 To uBound( arToSort, 1 ) - 1
				tempValue = arToSort( e, smallestIndex )
				arToSort( e, smallestIndex ) = arToSort( e, c )
				arToSort( e, c ) = tempValue
			Next
		End if
	
	Next
	arraySort = arToSort
end function




